<?php

include_once('./config/site.inc.php');

$request__ix = check_request('ix',CV_MD5  ,'');
$request__pg = check_request('pg',CV_DIGIT,0);

$fid_index = PATH_CACHE.'/'.$request__ix.CACHE_EXT_INDEX;
$fid_list  = PATH_CACHE.'/'.$request__ix.CACHE_EXT_LIST;

if (!file_exists($fid_index)) {
	die('error:ix not found');
}

$path = file_get_contents($fid_index);
$fid_comic = PATH_COMIC.'/'.$path;

if ($request__ix=='') {
	die('error:empty ix');
}


// zipファイルのエントリリストを取得(画像ファイルに限定)
if (!file_exists($fid_list) || true) {
	$entry_data = array();
	$entry_name = array();
	$zip = zip_open($fid_comic);
	$no = -1;
	$img = array(NULL,NULL);
	while(($zip_entry = zip_read($zip)) !== false){
		$no++;
		$zip_entry_name = zip_entry_name($zip_entry);
		$zip_entry_type = common__get_fileext($zip_entry_name);
		if ($zip_entry_type=='' || mb_strpos('jpg/jpeg/png/gif',$zip_entry_type)===false) continue;
		$entry_data[] = array(
			'no'   => $no,
			'name' => $zip_entry_name,
			'size' => zip_entry_filesize($zip_entry),
		);
		$entry_name[] = $zip_entry_name;
	}
	zip_close($zip);
	array_multisort($entry_name, SORT_ASC, $entry_data);
	file_put_contents($fid_list,serialize($entry_data));
} else {
	$entry_data = unserialize(file_get_contents($fid_list));
}

// ページ番号からzip内番号に変換する
$zip_no[0] = isset($entry_data[$request__pg  ]) ? $entry_data[$request__pg  ]['no'] : -1;
$zip_no[1] = isset($entry_data[$request__pg+1]) ? $entry_data[$request__pg+1]['no'] : -1;

// zipファイルから指定されたページとその次ページを持ってくる
$zip = zip_open($fid_comic);
$no = 0;
$img = array(NULL,NULL);
while(($zip_entry = zip_read($zip)) !== false){
	foreach ($zip_no as $pgid => $target_no) {
		if ($no==$target_no) {
			$img[$pgid] = zip_entry_read($zip_entry,zip_entry_filesize($zip_entry));
		}
	}
	if (!is_null($img[0]) && !is_null($img[1])) break;
	$no++;
}
zip_close($zip);


// 画像を作成して出力する
if (is_null($img[0])) {

	// ページが無かった場合
	echo "no image";

} else if (is_null($img[1])) {

	// 1ページしか無かった場合
	header("Content-type: image/jpeg");
	echo $img[0];

} else {

	// 2ページある

	// GDイメージを作成
	for ($pgid=0;$pgid<=1;$pgid++) {
		$img[$pgid] = imagecreatefromstring($img[$pgid]);
		$sx[$pgid] = imagesx($img[$pgid]);
		$sy[$pgid] = imagesy($img[$pgid]);
	}

	// 
	if ($sx[0]>$sy[0] || $sx[1]>$sy[1]) {
		// 横長ページが含まれるときは、1ページ目のみを戻す
		header("Content-type: image/jpeg");
		imagejpeg($img[0]);
	} else {
		// 2ページを並べる
		$vx = $sx[0]+$sx[1];
		$vy = ($sy[0]>$sy[1] ? $sy[0] : $sy[1]);
		$view = imagecreatetruecolor($vx,$vy);
		header("Content-type: image/jpeg");
		imagecopy($view,$img[0],$sx[1],($vy-$sy[0])/2,0,0,$sx[0],$sy[0]);
		imagecopy($view,$img[1],0,($vy-$sy[1])/2,0,0,$sx[1],$sy[1]);
		imagejpeg($view);
	}


}

?>